<?php
require_once '../../../wp-load.php';

if (!defined('MEMBER_VERSION') || !isset($member_module))
{
	die('no mioweb');
}

// start logging
$logId = false;
if (class_exists('clipsan_user', false))
{
	$wpdb->insert(clipsan_user::getInstance()->getLogTableName(), array(
		'request' => $_SERVER['REQUEST_URI'] . "\n" . print_r($_REQUEST, true),
		'ip' => $_SERVER['REMOTE_ADDR'],
		'added' => Date("Y-m-d H:i:s", current_time('timestamp'))
	));
	$logId = $wpdb->insert_id;
}

// finish logging and flush response
function finish($result, $logId, $userId = null)
{
	global $wpdb;
	if ($logId)
	{
		$wpdb->update(clipsan_user::getInstance()->getLogTableName(), array(
			'response' => $result,
			'user_id' => $userId
		), array(
			'id' => $logId
		));
	}
	die("$result");
}

// check security
$securekey = get_option('clipsan_securekey');
$security = sha1($_REQUEST['login'] . $_REQUEST['email'] . $_REQUEST['pass'] . $_REQUEST['t'] . $securekey);
if ($security != $_REQUEST['hash'])
{
	finish('invalid security', $logId);
}

// prepare data
$client = array(
	'email' => $_REQUEST['email'],
	'first_name' => $_REQUEST['firstname'],
	'last_name' => $_REQUEST['surname'],
	'password' => $_REQUEST['pass']
);

$client['billing_user_id'] = isset($_GET['billing_user_id']) && !empty($_GET['billing_user_id']) ? $_GET['billing_user_id'] : null;

// send email?
$send_email = isset($_GET['notify']) ? (bool) $_GET['notify'] : true;

if (isset($_REQUEST['reg']) && preg_match('/\d{4}-\d{2}-\d{2} \d{2}:\d{2}/', $_REQUEST['reg']))
{
	$date = new DateTime($_REQUEST['reg'] . ':00');
	$client['user_registered'] = $_REQUEST['reg'] . ':00';
	$reg_date = $date->format("d.m.Y");
	$reg_time = $date->format("H:i");
}
else
{
	$reg_date = Date("d.m.Y", current_time('timestamp'));
	$reg_time = Date("H:i", current_time('timestamp'));
}

if (isset($_GET['days']) && $_GET['days'])
{
	$days = (isset($_GET['days'])) ? (int) $_GET['days'] : '';
	$end = Date("d.m.Y", strtotime($reg_date) + ($days * 86400));
}
else
{
	$end = '';
}

if (isset($_GET['level']))
{
	$add_level = explode('-', $_GET['level']);
}
else
{
	if (isset($_GET['addlevel']))
	{
		$add_level = explode('-', $_GET['addlevel']);
	}
	else
	{
		$add_level = false;
	}
}

/* FIND EXISTING USER */
$user = null;
if (!$user && !empty($client['billing_user_id']))
{
	$users = get_users(array(
		'meta_key' => META_BILLING_ID,
		'meta_value' => $client['billing_user_id']
	));
	if (is_array($users) && count($users) > 0) $user = $users[0];
}
if (!$user) $user = get_user_by('email', $client['email']);
if (!$user) $user = get_user_by('login', $client['email']);

$sectionId = isset($_GET['add_new_member']) ? $_GET['add_new_member'] : -1;

if (!$user)
{
	/* CREATE NEW USER
	 ******************** */
	$member_option = get_option('member_basic');
	
	if (isset($member_option['members'][$sectionId]))
	{
		
		$levels = array();
		if ($add_level)
		{
			foreach ($add_level as $al)
			{
				$levels[$al] = 1;
			}
		}
		
		$subject = (isset($member_option['members'][$sectionId]['email_subject'])) ? $member_option['members'][$sectionId]['email_subject'] : "";
		$new_user = $member_module->create_new_member_user($client, array(
			$sectionId => array(
				'section' => 1,
				'levels' => $levels,
				'date' => $reg_date,
				'time' => $reg_time,
				'end' => $end
			)
		), $send_email, $member_option['members'][$sectionId]['email_text'], $subject);
		
		$user_id = $new_user['user_id'];
		
		// Store billing id.
		update_user_meta($user_id, META_BILLING_ID, $client['billing_user_id']);
		
		// return json?
		$return_json = isset($_GET['return_json']) ? (bool) $_GET['return_json'] : false;
		if ($return_json)
		{
			echo json_encode(array(
				'loginUrl' => get_permalink($member_option['members'][$sectionId]['dashboard']),
				'username' => $new_user['user_login'],
				'password' => $new_user['user_password']
			));
		}
		
		finish($user_id . ':' . $new_user['user_login'], $logId, $user_id);
	}
	else
	{
		finish(sprintf(__('Sekce s ID=[%s] neexistuje. ', 'cms_member'), $sectionId), $logId);
	}
}
else
{
	/* UPDATE EXISTING USER
	 ******************** */
	$user_id = $user->ID;
	$member_meta = get_the_author_meta('cms_member', $user_id);
	$member_option = get_option('member_basic');
	
	//Update billing user id, only if present.
	if (!empty($client['billing_user_id'])) update_user_meta($user_id, META_BILLING_ID, $client['billing_user_id']);
	
	$new_level = false;
	$new_member = false;
	$new_expiration = false;
	
	if (isset($member_option['members'][$sectionId]))
	{
		
		if (isset($_GET['addlevel']) && isset($member_meta[$sectionId]) && isset($member_meta[$sectionId]['levels']))
			$old_levels = $member_meta[$sectionId]['levels'];
		else
			$old_levels = array();
		
		if (isset($_GET['addlevel']) && (!empty($_GET['addlevel']) || $_GET['addlevel'] === "0"))
		{
			// Preserve old levels
			$levels = $old_levels;
		}
		else
		{
			$levels = array();
		}
		
		if ($add_level)
		{
			foreach ($add_level as $al)
			{
				$levels[$al] = 1;
				if (!isset($old_levels[$al]))
				{
					$new_level = true;
				}
			}
		}
		
		$return_json = isset($_GET['return_json']) ? (bool) $_GET['return_json'] : false;
		if ($return_json)
		{
			echo json_encode(array(
				'loginUrl' => get_permalink($member_option['members'][$sectionId]['dashboard']),
				'username' => $client['email']
			));
		}
	}
	else
	{
		$levels = array();
	}
	
	if (isset($member_meta) && is_array($member_meta))
	{
		//if is in member already
		if (isset($member_meta[$sectionId]))
		{
			$reg_date = $member_meta[$sectionId]['date'];
			$reg_time = $member_meta[$sectionId]['time'];
			if (isset($member_meta[$sectionId]['end'])) $end = $member_meta[$sectionId]['end'];
			// add member time
			if (isset($days) && $days && isset($member_meta[$sectionId]['end']))
			{
				$old_end = strtotime($member_meta[$sectionId]['end']);
				$end = ($old_end > current_time('timestamp')) ? Date("d.m.Y", $old_end + ($days * 86400)) : Date("d.m.Y", current_time('timestamp') + ($days * 86400));
				$new_expiration = true;
			}
		}
		else
		{
			$new_member = true;
		}
		
		$member_meta[$sectionId] = array(
			'section' => 1,
			'levels' => $levels,
			'date' => $reg_date,
			'time' => $reg_time,
			'end' => $end
		);
		update_user_meta($user_id, 'cms_member', $member_meta);
	}
	else
	{
		add_user_meta($user_id, 'cms_member', array(
			$sectionId => array(
				'section' => 1,
				'levels' => $levels,
				'date' => $reg_date,
				'time' => $reg_time,
				'end' => $end
			)
		));
	}
	
	$message = '';
	if ($new_member)
	{
		$subject = $member_option['members'][$sectionId]['email_subject'];
		$message = $member_option['members'][$sectionId]['email_text'];
		
		if (!$subject) $subject = __('Přístup do členské sekce', 'cms_member');
		if (!$message)
		{
			$message = __('Dobrý den,', 'cms_member');
			$message .= "\n\n";
			$message .= __('byly Vám vygenerovány přístupy:', 'cms_member');
			$message .= "\n\n";
			$message .= "%%login%%";
			$message .= "\n\n";
		}
	}
	else
	{
		if ($new_level)
		{
			echo 'level';
			$subject = (isset($member_option['members'][$sectionId]['level_email_subject'])) ? $member_option['members'][$_GET['add_new_member']]['level_email_subject'] : '';
			$message = (isset($member_option['members'][$sectionId]['level_email_text'])) ? $member_option['members'][$_GET['add_new_member']]['level_email_text'] : '';
			
			if (!$subject) $subject = __('Přidány přístupy do členské úrovně', 'cms_member');
			if (!$message)
			{
				$message = __('Dobrý den,', 'cms_member');
				$message .= "\n\n";
				$message .= __('byl Vám povolen přístup do nové členské úrovně v:', 'cms_member');
				$message .= "\n\n";
				$message .= "%%login%%";
				$message .= "\n\n";
			}
		}
		else
		{
			if ($new_expiration)
			{
				echo 'expirace';
				$subject = (isset($member_option['members'][$sectionId]['expiration_email_subject'])) ? $member_option['members'][$_GET['add_new_member']]['expiration_email_subject'] : '';
				$message = (isset($member_option['members'][$sectionId]['expiration_email_text'])) ? $member_option['members'][$_GET['add_new_member']]['expiration_email_text'] : '';
				
				if (!$subject) $subject = __('Prodloužení členství', 'cms_member');
				if (!$message)
				{
					$message = __('Dobrý den,', 'cms_member');
					$message .= "\n\n";
					$message .= __('bylo Vám prodlouženo členství:', 'cms_member');
					$message .= "\n\n";
					$message .= "%%login%%";
					$message .= "\n\n";
				}
			}
			else
			{
				$send_email = false;
			}
		}
	}
	
	if ($send_email)
	{
		
		$message = str_replace("%%login%%", $member_module->create_user_login_message($client['email'], __('Vaše heslo bylo již vygenerováno v předchozí registraci na tomto webu. (Pokud si heslo nepamatujete, vygenerujte si na přihlašovací stránce nové.)', 'cms_member'), array(
			$sectionId => array(
				'section' => 1
			)
		), $member_option), $message);
		
		$header = 'From: ' . get_bloginfo('name') . ' <' . get_bloginfo('admin_email') . '>';
		
		wp_mail($client['email'], $subject, $message, $header);
	}
	
	finish(sprintf(__('Uživatel %s byl aktualizován.', 'cms_member'), $client['email']), $logId, $user_id);
}